<template>
  <CCard>
    <CCardHeader>
      <slot name="header">
        <CIcon name="cil-grid" /> {{ caption }}
      </slot>
    </CCardHeader>

    <CCardBody>
      <CDataTable
        hover
        striped
        bordered
        small
        fixed
        :items="items"
        :fields="fields"
        :items-per-page="small ? 10 : 5"
        pagination
      >
        <template #edit="{item}">
          <td>
            <CRow>
              <CNav>
                <CNavItem active>
                  <CButton
                    color="secondary"
                    class="mr-1"
                    @click="onShowDetail(item.id)"
                  >
                    Edit
                  </CButton>
                </CNavItem>
              </CNav>
            </CRow>
          </td>
          <CModal
            title="Edit Shedule"
            size="lg"
            :show.sync="isEditShedule"
          >
            <ScheduleForm :shedule-item="sheduleItem" />
          </CModal>
        </template>
      </CDataTable>
    </CCardBody>
  </CCard>
</template>

<script>
import ScheduleForm from '~/components/organisms/schedules/ScheduleForm'

// const EVENT_DELETE = 'delete'
const EVENT_SHOW_DETAIL = 'show-detail'

export default {
  name: 'Table',

  components: {
    ScheduleForm
  },

  props: {
    items: {
      type: Array,
      default: () => {}
    },
    fields: {
      type: Array,
      default: () => {}
    },
    caption: {
      type: String,
      default: 'Table'
    },
    small: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      isEditShedule: false,
      sheduleItem: {},
      details: []
    }
  },

  methods: {
    /**
     * Event show user detail modal
     *
     * @param {string} user - User
     */
    onShowDetail (id) {
      this.$emit(EVENT_SHOW_DETAIL, id)
    },

    toggleDetails (index) {
      const position = this.details.indexOf(index)
      position !== -1 ? this.details.splice(position, 1) : this.details.push(index)
    }
  }

}
</script>

<style>
.table {
  width: 100%;
}
.table td {
  vertical-align: 0px;
  padding: 0 12px;
}
</style>
